import 'bloc.dart';
import '../datalayer/entity/tanktimesheet/tanktimesheetbean.dart';
import '../service/tanktimesheet/tanktimesheet_service.dart';

class TanktimesheetQueryBloc extends Bloc<List<TankTimesheetBean>> {

  TankTimesheetService service = TankTimesheetService();
  String prevQuery = "";

  void submitQuery(String query) async {
    prevQuery = query;
    final results = await service.fetchTimesheet(query, 1, 20);

    if (results.error != null) {
      print("Fetch timesheet error: ${results.error.message}");
    }
    else {
      sinkAdd(results.entities);
    }
  }

  void saveTimesheet(TankTimesheetBean timesheet) async {
    await service.saveTimesheet([timesheet]);
    submitQuery(prevQuery);
  }
}