import 'package:ingdao/dataflow/entity/dfbaseentity.dart';
import 'package:ingdao/dataflow/entity/dfdbentity.dart';
import 'package:ingdao/dataflow/field/dfbasefield.dart';
import 'package:ingdao/dataflow/field/dfdbfield.dart';
import 'package:ingdao/dataflow/field/dffieldtype.dart';
import 'package:ingdao/dataflow/field/dfstringvalidator.dart';
import 'package:ingdao/dataflow/field/dfdatetimevalidator.dart';
import '../../field/tanktimesheet/tanktimesheet_field.dart';

class TankTimesheet extends DfDbEntity with TankTimesheetField {
    
  TankTimesheet ({String id, String tankId, String name, DateTime markOn, bool active}) : super(name: "tanktimesheet") {
    fId = DfDbField(entity: this, name: "id", primaryKey: true, joinKey: false, fieldType: DfFieldType.text(), value: id);
    fTankId = DfDbField(entity: this, name: "tankid", primaryKey: false, joinKey: true, fieldType: DfFieldType.text(), value: tankId);
    fName = DfDbField(entity: this, name: "name", primaryKey: false, joinKey: false, fieldType: DfFieldType.text(strValidator: DfStringValidator(isAllowEmpty: false, minLen: 5, maxLen: 100, isAlphaAndSpaceAndDigitOnly: true)), value: name);
    fMarkOn = DfDbField(entity: this, name: "markon", primaryKey: false, joinKey: false, fieldType: DfFieldType.datetime(dateTimeValidator: DfDateTimeValidator(isLtNowCheck: true)), value: markOn);
    fActive = DfDbField(entity: this, name: "active", primaryKey: false, joinKey: false, fieldType: DfFieldType.boolean(), value: active);
    //fTankName = DfDbField(entity: Tank(), name: "name", primaryKey: false, joinKey: false, fieldType: DfFieldType.text(), displayOnly: true);
  }

  //Define the sqilite table fields available.
  //Define the fields will map back to the sqlite query executed reuslt: Map<String,dynamic>
  @override
  List<DfDbField> fields() {
     return [fId,fTankId,fName,fMarkOn,fActive/*,fTankName*/];
  }

  @override
  DfBaseEntity<DfBaseField> newInstance() {
    return TankTimesheet();
  }
}