import 'package:ingdao/dataflow/control/dfquery.dart';
import 'package:ingdao/dataflow/control/dfqueryorderby.dart';
import 'package:ingdao/dataflow/entity/dfbaseentity.dart';
import 'package:ingdao/dataflow/entity/dfwebentity.dart';
import 'package:ingdao/dataflow/field/dfbasefield.dart';
import 'package:ingdao/dataflow/field/dfwebfield.dart';
import '../../field/tanktimesheet/tanktimesheet_field.dart';
import 'package:ingdao/dataflow/field/dffieldtype.dart';

class TankTimesheetWeb extends DfWebEntity with TankTimesheetField {
  TankTimesheetWeb ({String id, String tankId, String name, DateTime markOn, bool active}) : super(contextPath: "tanktimesheet") {
    fId = DfWebField(entity: this, name: "id", fieldType: DfFieldType.text(), value: id);
    fTankId = DfWebField(entity: this, name: "tankId", fieldType: DfFieldType.text(), value: tankId);
    fName = DfWebField(entity: this, name: "name", fieldType: DfFieldType.text(), value: name);
    fMarkOn = DfWebField(entity: this, name: "markOn", fieldType: DfFieldType.datetime(), value: markOn);
    fActive = DfWebField(entity: this, name: "active", fieldType: DfFieldType.boolean(), value: active);
  }

  //Define what are the fields will map back the result from http response Map<String,dynamic>
  @override
  List<DfWebField> fields() {
     return [fId,fTankId,fName,fMarkOn,fActive];
  }

  @override
  DfWebReqParam convertToWebReqParam(DfQuery query) {
    if (query.purpose == DfQueryPurpose.FETCH) {
      DfWebReqParam param = DfWebReqParam();

      if (query.paging != null) {
        param.reqParams["pageNumber"] = "${query.paging.pageNumber}";
        param.reqParams["perPageCount"] = "${query.paging.perPageCount}";
      }
        
      if (query.orderBy != null) {
        int i = 0;
        for (var orderBy in query.orderBy) {
          ++i;
          param.reqParams["orderBy$i"] = orderBy.field.name;
          param.reqParams["asc$i"] = orderBy.orderByType ==OrderByType.asc ? "true" : "false";
        }
      }

        if (query.criteriaGroup != null) {
          for (var cri in query.criteriaGroup.criterias) {
            param.pathVariables.add(cri.values[0]);
          }
        }

        return param;
    }
    return null;
  }

  @override
  DfBaseEntity<DfBaseField> newInstance() {
    return TankTimesheetWeb();
  }
}