import 'package:meta/meta.dart';
import '../entity/dfbaseentity.dart';
import '../field/dffieldtype.dart';

abstract class DfBaseField {

  DfBaseEntity entity;
  String name;
  bool displayOnly = false;
  DfFieldType fieldType;
  var value;

  DfBaseField({@required this.entity, @required this.name, @required this.fieldType, this.displayOnly, this.value}) {
    if (fieldType != null && fieldType.validator != null)
      fieldType.validator.field = this;    
  }

  String valueAsString() {
    return value;
  }

  DateTime valueAsDateTime() {
    return value;
  }

  bool valueAsBool() {
    return value;
  }

  int valueAsInt() {
    return value;
  }

  double valueAsDouble() {
    return value;
  }

  setValueFromQueryResult(Map<String,dynamic> dict);

  @override
  bool operator ==(Object other) => other is DfBaseField && other.name == name && other.entity.name == entity.name;

  @override
  int get hashCode => name.hashCode + entity.name.hashCode;  

}